package  
{
	/**
	 * ...
	 * @author Guchan Alkan
	 */
	public class DataGenerator 
	{
		
		public static function randomData(dataLength:int):Array
		{
			var i:int, temp:int, randomOne:int, randomTwo:int;
			var array:Array = [];
			
			for (i = 0; i < dataLength; i++)
			{
				array.push(i);
			}
			
			for (i = 0; i < dataLength; i++)
			{
				randomOne = int(Math.random() * dataLength);
				randomTwo = int(Math.random() * dataLength);
				
				temp = array[randomOne]
				array[randomOne] = array[randomTwo];
				array[randomTwo] = temp;
			}
			
			return array;
		}
		
		public static function nearlySortedData(dataLength:int):Array
		{
			var i:int, temp:int, randomOne:int, randomTwo:int;
			var array:Array = [];
			
			for (i = 0; i < dataLength; i++)
			{
				array.push(i);
			}
			
			for (i = 0; i < dataLength / 10; i++)
			{
				randomOne = int(Math.random() * dataLength);
				randomTwo = int(Math.random() * dataLength);
				
				temp = array[randomOne]
				array[randomOne] = array[randomTwo];
				array[randomTwo] = temp;
			}
			
			return array;
		}
		
		public static function reversedSortedData(dataLength:int):Array
		{
			var array:Array = [];
			for (var i:int = dataLength; i > 0; i--)
			{
				array.push(i - 1);
			}
			
			return array;
		}
		
		public static function fewUniqueData(dataLength:int):Array
		{
			var i:int, temp:int, randomOne:int, randomTwo:int;
			var array:Array = [];
			
			for (i = 0; i < dataLength; i++)
			{
				array.push(i % 10);
			}
			
			for (i = 0; i < dataLength; i++)
			{
				randomOne = int(Math.random() * dataLength);
				randomTwo = int(Math.random() * dataLength);
				
				temp = array[randomOne]
				array[randomOne] = array[randomTwo];
				array[randomTwo] = temp;
			}
			
			return array;
		}
		
	}

}